/*
   @(#)MavenBuildProjectComponent.java   2006-10-24
 

                                 Apache License
                           Version 2.0, January 2004
                        http://www.apache.org/licenses/

   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION

   1. Definitions.

      "License" shall mean the terms and conditions for use, reproduction,
      and distribution as defined by Sections 1 through 9 of this document.

      "Licensor" shall mean the copyright owner or entity authorized by
      the copyright owner that is granting the License.

      "Legal Entity" shall mean the union of the acting entity and all
      other entities that control, are controlled by, or are under common
      control with that entity. For the purposes of this definition,
      "control" means (i) the power, direct or indirect, to cause the
      direction or management of such entity, whether by contract or
      otherwise, or (ii) ownership of fifty percent (50%) or more of the
      outstanding shares, or (iii) beneficial ownership of such entity.

      "You" (or "Your") shall mean an individual or Legal Entity
      exercising permissions granted by this License.

      "Source" form shall mean the preferred form for making modifications,
      including but not limited to software source code, documentation
      source, and configuration files.

      "Object" form shall mean any form resulting from mechanical
      transformation or translation of a Source form, including but
      not limited to compiled object code, generated documentation,
      and conversions to other media types.

      "Work" shall mean the work of authorship, whether in Source or
      Object form, made available under the License, as indicated by a
      copyright notice that is included in or attached to the work
      (an example is provided in the Appendix below).

      "Derivative Works" shall mean any work, whether in Source or Object
      form, that is based on (or derived from) the Work and for which the
      editorial revisions, annotations, elaborations, or other modifications
      represent, as a whole, an original work of authorship. For the purposes
      of this License, Derivative Works shall not include works that remain
      separable from, or merely link (or bind by name) to the interfaces of,
      the Work and Derivative Works thereof.

      "Contribution" shall mean any work of authorship, including
      the original version of the Work and any modifications or additions
      to that Work or Derivative Works thereof, that is intentionally
      submitted to Licensor for inclusion in the Work by the copyright owner
      or by an individual or Legal Entity authorized to submit on behalf of
      the copyright owner. For the purposes of this definition, "submitted"
      means any form of electronic, verbal, or written communication sent
      to the Licensor or its representatives, including but not limited to
      communication on electronic mailing lists, source code control systems,
      and issue tracking systems that are managed by, or on behalf of, the
      Licensor for the purpose of discussing and improving the Work, but
      excluding communication that is conspicuously marked or otherwise
      designated in writing by the copyright owner as "Not a Contribution."

      "Contributor" shall mean Licensor and any individual or Legal Entity
      on behalf of whom a Contribution has been received by Licensor and
      subsequently incorporated within the Work.

   2. Grant of Copyright License. Subject to the terms and conditions of
      this License, each Contributor hereby grants to You a perpetual,
      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
      copyright license to reproduce, prepare Derivative Works of,
      publicly display, publicly perform, sublicense, and distribute the
      Work and such Derivative Works in Source or Object form.

   3. Grant of Patent License. Subject to the terms and conditions of
      this License, each Contributor hereby grants to You a perpetual,
      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
      (except as stated in this section) patent license to make, have made,
      use, offer to sell, sell, import, and otherwise transfer the Work,
      where such license applies only to those patent claims licensable
      by such Contributor that are necessarily infringed by their
      Contribution(s) alone or by combination of their Contribution(s)
      with the Work to which such Contribution(s) was submitted. If You
      institute patent litigation against any entity (including a
      cross-claim or counterclaim in a lawsuit) alleging that the Work
      or a Contribution incorporated within the Work constitutes direct
      or contributory patent infringement, then any patent licenses
      granted to You under this License for that Work shall terminate
      as of the date such litigation is filed.

   4. Redistribution. You may reproduce and distribute copies of the
      Work or Derivative Works thereof in any medium, with or without
      modifications, and in Source or Object form, provided that You
      meet the following conditions:

      (a) You must give any other recipients of the Work or
          Derivative Works a copy of this License; and

      (b) You must cause any modified files to carry prominent notices
          stating that You changed the files; and

      (c) You must retain, in the Source form of any Derivative Works
          that You distribute, all copyright, patent, trademark, and
          attribution notices from the Source form of the Work,
          excluding those notices that do not pertain to any part of
          the Derivative Works; and

      (d) If the Work includes a "NOTICE" text file as part of its
          distribution, then any Derivative Works that You distribute must
          include a readable copy of the attribution notices contained
          within such NOTICE file, excluding those notices that do not
          pertain to any part of the Derivative Works, in at least one
          of the following places: within a NOTICE text file distributed
          as part of the Derivative Works; within the Source form or
          documentation, if provided along with the Derivative Works; or,
          within a display generated by the Derivative Works, if and
          wherever such third-party notices normally appear. The contents
          of the NOTICE file are for informational purposes only and
          do not modify the License. You may add Your own attribution
          notices within Derivative Works that You distribute, alongside
          or as an addendum to the NOTICE text from the Work, provided
          that such additional attribution notices cannot be construed
          as modifying the License.

      You may add Your own copyright statement to Your modifications and
      may provide additional or different license terms and conditions
      for use, reproduction, or distribution of Your modifications, or
      for any such Derivative Works as a whole, provided Your use,
      reproduction, and distribution of the Work otherwise complies with
      the conditions stated in this License.

   5. Submission of Contributions. Unless You explicitly state otherwise,
      any Contribution intentionally submitted for inclusion in the Work
      by You to the Licensor shall be under the terms and conditions of
      this License, without any additional terms or conditions.
      Notwithstanding the above, nothing herein shall supersede or modify
      the terms of any separate license agreement you may have executed
      with Licensor regarding such Contributions.

   6. Trademarks. This License does not grant permission to use the trade
      names, trademarks, service marks, or product names of the Licensor,
      except as required for reasonable and customary use in describing the
      origin of the Work and reproducing the content of the NOTICE file.

   7. Disclaimer of Warranty. Unless required by applicable law or
      agreed to in writing, Licensor provides the Work (and each
      Contributor provides its Contributions) on an "AS IS" BASIS,
      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
      implied, including, without limitation, any warranties or conditions
      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
      PARTICULAR PURPOSE. You are solely responsible for determining the
      appropriateness of using or redistributing the Work and assume any
      risks associated with Your exercise of permissions under this License.

   8. Limitation of Liability. In no event and under no legal theory,
      whether in tort (including negligence), contract, or otherwise,
      unless required by applicable law (such as deliberate and grossly
      negligent acts) or agreed to in writing, shall any Contributor be
      liable to You for damages, including any direct, indirect, special,
      incidental, or consequential damages of any character arising as a
      result of this License or out of the use or inability to use the
      Work (including but not limited to damages for loss of goodwill,
      work stoppage, computer failure or malfunction, or any and all
      other commercial damages or losses), even if such Contributor
      has been advised of the possibility of such damages.

   9. Accepting Warranty or Additional Liability. While redistributing
      the Work or Derivative Works thereof, You may choose to offer,
      and charge a fee for, acceptance of support, warranty, indemnity,
      or other liability obligations and/or rights consistent with this
      License. However, in accepting such obligations, You may act only
      on Your own behalf and on Your sole responsibility, not on behalf
      of any other Contributor, and only if You agree to indemnify,
      defend, and hold each Contributor harmless for any liability
      incurred by, or claims asserted against, such Contributor by reason
      of your accepting any such warranty or additional liability.

   END OF TERMS AND CONDITIONS

   Copyright 2006 Ralf Quebbemann

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */


package de.qu.idea.plugin.maven;

import com.intellij.openapi.application.Application;
import com.intellij.openapi.application.ApplicationManager;
import com.intellij.openapi.components.ProjectComponent;
import com.intellij.openapi.options.Configurable;
import com.intellij.openapi.options.ConfigurationException;
import com.intellij.openapi.project.Project;
import com.intellij.openapi.roots.ProjectRootManager;
import com.intellij.openapi.util.IconLoader;
import com.intellij.openapi.util.InvalidDataException;
import com.intellij.openapi.util.JDOMExternalizable;
import com.intellij.openapi.util.JDOMExternalizerUtil;
import com.intellij.openapi.util.WriteExternalException;
import com.intellij.openapi.vfs.LocalFileSystem;
import com.intellij.openapi.vfs.VirtualFile;
import com.intellij.openapi.wm.ToolWindow;
import com.intellij.openapi.wm.ToolWindowAnchor;
import com.intellij.openapi.wm.ToolWindowManager;
import de.qu.idea.plugin.maven.config.IdeaMavenPluginDocument;
import de.qu.idea.plugin.maven.config.PluginConfigDocument;
import de.qu.idea.plugin.maven.gui.PomTree;
import de.qu.idea.plugin.maven.gui.form.MavenBuildProjectToolWindowForm;
import de.qu.idea.plugin.maven.gui.form.MavenProjectConfigurationForm;
import de.qu.idea.plugin.maven.model.MavenBuildPluginApplicationSettings;
import de.qu.idea.plugin.maven.model.MavenBuildProjectPluginSettings;
import de.qu.idea.plugin.maven.model.MavenPluginDocument;
import de.qu.idea.plugin.maven.model.MavenProjectDocument;
import de.qu.idea.plugin.maven.model.MavenProjectDocumentImpl;
import de.qu.idea.plugin.maven.util.ActionUtils;
import de.qu.idea.plugin.maven.util.ErrorHandler;
import de.qu.idea.plugin.maven.util.GuiUtils;
import de.qu.idea.plugin.maven.util.PluginConstants;
import org.apache.commons.lang.StringUtils;
import org.apache.log4j.Logger;
import org.apache.maven.settings.SettingsDocument;
import org.apache.xmlbeans.XmlOptions;
import org.jdom.Element;
import org.jetbrains.annotations.Nls;
import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import javax.swing.*;
import java.io.File;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * Describe what this class does.
 *
 * @author Ralf Quebbemann
 * @version $Revision$
 */
public class MavenBuildProjectComponent
    implements ProjectComponent, Configurable, JDOMExternalizable {

  /**
   * Field description
   */
  public static final String BUILD_TOOL_WINDOW_ID = "Maven 2 Build";

  /**
   * Field description
   */
  public static final String OUTPUT_TOOL_WINDOW_ID = "Maven 2 Build Output";
  private static final Logger LOG = Logger.getLogger(MavenBuildProjectComponent.class);
  private List<MavenProjectDocument> pomDocumentList = new ArrayList<MavenProjectDocument>();
  private MavenBuildProjectPluginSettings pluginSettings = new MavenBuildProjectPluginSettings();
  private PluginContext pluginContext = new PluginContext();
  private Set<MavenProjectDocument> mavenPomList = new LinkedHashSet<MavenProjectDocument>();
  private MavenProjectConfigurationForm form;
  private MavenBuildApplicationComponent mavenBuildApplicationComponent;
  private MavenBuildProjectToolWindowForm mavenToolWindowForm;
  private Project pluginProject;

  /**
   * Constructs ...
   *
   * @param project Document me!
   */
  public MavenBuildProjectComponent(Project project) {
    pluginProject = project;
    mavenToolWindowForm = new MavenBuildProjectToolWindowForm(pluginContext);
  }

  /**
   * Method description
   *
   * @throws ConfigurationException
   */
  public void apply() throws ConfigurationException {
    if (form != null) {
      form.getData(pluginSettings);
    }
  }

  /**
   * Method description
   *
   * @return Document me!
   */
  public JComponent createComponent() {
    if (form == null) {
      form = new MavenProjectConfigurationForm();
    }

    return form.getRootComponent();
  }

  private void createPomTree()
      throws org.apache.xmlbeans.XmlException, java.io.IOException, IdeaMavenPluginException {
    for (MavenProjectDocument mavenProjectDocument : mavenPomList) {
      ActionUtils.addSinglePomToTree(pluginContext, mavenProjectDocument);
    }
  }

  /**
   * Method description
   */
  public void disposeComponent() {

    // empty
  }

  /**
   * Method description
   */
  public void disposeUIResources() {
    form = null;
  }

  /**
   * Method description
   */
  public void initComponent() {
    MavenBuildPluginApplicationSettings pluginApplicationSettings;
    Application application = ApplicationManager.getApplication();

    mavenBuildApplicationComponent = application.getComponent(MavenBuildApplicationComponent.class);

    if (mavenBuildApplicationComponent != null) {
      pluginApplicationSettings = mavenBuildApplicationComponent.getPluginSettings();
      LOG.debug("Scan for existing POMs is: " + pluginApplicationSettings.isScanForExistingPoms());
    }
  }

  private void initToolWindow(JTree tree) {
    JPanel pomContentPanel;
    ToolWindowManager toolWindowManager = ToolWindowManager.getInstance(pluginProject);

    mavenToolWindowForm.getScrollpane().setViewportView(tree);
    pomContentPanel = mavenToolWindowForm.getPanel();

    // createToolbar(mavenToolWindowForm);
    ToolWindow pomToolWindow = toolWindowManager.registerToolWindow(BUILD_TOOL_WINDOW_ID,
        pomContentPanel, ToolWindowAnchor.RIGHT);

    pomToolWindow.setIcon(GuiUtils.createImageIcon(PluginConstants.ICON_APPLICATION_EMBLEM_SMALL));

//  myToolWindow.setTitle("Maven2 Build");
  }

  /**
   * Method description
   */
  public void projectClosed() {
    unregisterToolWindow();
  }

  /**
   * Method description
   */
  public void projectOpened() {
    PomTree pomTree;
    MavenBuildPluginApplicationSettings pluginApplicationSettings = null;

    pluginContext.setProjectComponent(this);

    ProjectRootManager projectRootManager = ProjectRootManager.getInstance(pluginProject);

    // should be non null, because it was queried in initComponent()
    if (mavenBuildApplicationComponent != null) {
      pluginApplicationSettings = mavenBuildApplicationComponent.getPluginSettings();
    }

    Icon goalIcon = GuiUtils.createImageIcon(PluginConstants.ICON_APPLICATION_SMALL);
    Icon pomIcon = IconLoader.getIcon(PluginConstants.ICON_POM_SMALL);

    pomTree = new PomTree(getPluginContext(), PluginConstants.TREE_ROOT_NODE_TITLE, pomIcon,
        goalIcon);
    pluginContext.setPomTree(pomTree);

    if ((pluginApplicationSettings != null) && pluginApplicationSettings.isScanForExistingPoms()) {
      mavenPomList = getPomFilesOfProject(projectRootManager);
    }

    try {
      createPomTree();
    } catch (Exception e) {
      ErrorHandler.processAndShowError(pluginContext, e);
    }

    pomTree.setRootVisible(true);
    initToolWindow(pomTree);
  }

  /**
   * Method description
   *
   * @param element Document me!
   *
   * @throws InvalidDataException
   */
  public void readExternal(Element element) throws InvalidDataException {
    pluginSettings.setMavenExecutable(JDOMExternalizerUtil.readField(element, "mavenExecutable"));
    pluginSettings.setMavenOptions(JDOMExternalizerUtil.readField(element, "mavenOptions"));
    pluginSettings.setMavenCommandLineParams(JDOMExternalizerUtil.readField(element,
        "mavenCommandLineParams"));

//  pluginSettings.setMavenRepository(JDOMExternalizerUtil.readField(element, "mavenRepository"));

    String mavenHomeDir = System.getProperty("user.home") + System.getProperty("file.separator")
        + ".m2";
    LocalFileSystem localFileSystem = LocalFileSystem.getInstance();
    File settingsFile = new File(mavenHomeDir + System.getProperty("file.separator")
        + "settings.xml");

    if (settingsFile.exists()) {
      try {
        XmlOptions xmlOptions = new XmlOptions();
        Map<String, String> xmlOptionsMap = new Hashtable<String, String>();

        xmlOptionsMap.put("", "org/apache/maven/settings");
        xmlOptions.setLoadSubstituteNamespaces(xmlOptionsMap);
        SettingsDocument settingsDocument = SettingsDocument.Factory.parse(new File(mavenHomeDir
            + System.getProperty("file.separator")
            + "settings.xml"), xmlOptions);

        if (settingsDocument != null) {
          if (!StringUtils.isEmpty(settingsDocument.getSettings().getLocalRepository())) {
            pluginSettings.setMavenRepository(settingsDocument.getSettings().getLocalRepository());
          }
        }
      } catch (Exception e) {
        LOG.error(e);

        throw new InvalidDataException(e.getCause());
      }
    } else {
      pluginSettings.setMavenRepository(mavenHomeDir + System.getProperty("file.separator")
          + "repository");
    }

    LOG.debug("Location of Maven Repository is: " + pluginSettings.getMavenRepository());

    Element pomListElement = element.getChild("pom-list");

    if (pomListElement != null) {
      List myPomListChildren = pomListElement.getChildren("pom");

      for (Object aPomListChildren : myPomListChildren) {
        Element childElement = (Element) aPomListChildren;

        if (childElement != null) {
          Element pomOptionElement = childElement.getChild("option");
          String pomPath = pomOptionElement.getAttributeValue("value");
          VirtualFile virtualFile = localFileSystem.findFileByPath(pomPath);

          if (virtualFile != null) {
            MavenProjectDocument mavenProjectDocument = new MavenProjectDocumentImpl(virtualFile);

            mavenPomList.add(mavenProjectDocument);
            LOG.debug("Adding POM: " + virtualFile.getPath());

            Element pluginListChildren = childElement.getChild("plugin-list");

            if (pluginListChildren != null) {
              List myPluginListChildren = pluginListChildren.getChildren("option");

              for (Object pluginListElement : myPluginListChildren) {
                Element pluginChildElement = (Element) pluginListElement;
                String pluginPath = pluginChildElement.getAttributeValue("value");
                VirtualFile pluginJarArchive = localFileSystem.findFileByPath(pluginPath);

                try {
                  MavenPluginDocument mavenPluginDocument =
                      ActionUtils.createMavenPluginDocument(pluginJarArchive, true);

                  mavenProjectDocument.getPluginDocumentList().add(mavenPluginDocument);
                } catch (Exception e) {
                  LOG.error(e);

                  throw new InvalidDataException(e.getCause());
                }

                LOG.debug("Adding Plugin: " + pluginPath);
              }
            }
          }
        }
      }
    }
  }

  /**
   * Method description
   */
  public void reset() {
    if (form != null) {
      form.setData(pluginSettings);
    }
  }

  private void unregisterToolWindow() {
    ToolWindowManager toolWindowManager = ToolWindowManager.getInstance(pluginProject);

    toolWindowManager.unregisterToolWindow(BUILD_TOOL_WINDOW_ID);
  }

  /**
   * Method description
   *
   * @param element Document me!
   *
   * @throws WriteExternalException
   */
  public void writeExternal(Element element) throws WriteExternalException {
    JDOMExternalizerUtil.writeField(element, "mavenExecutable",
        pluginSettings.getMavenExecutable());
    JDOMExternalizerUtil.writeField(element, "mavenOptions", pluginSettings.getMavenOptions());
    JDOMExternalizerUtil.writeField(element, "mavenCommandLineParams",
        pluginSettings.getMavenCommandLineParams());

    Element pomListElement = new Element("pom-list");

    element.addContent(pomListElement);

    for (MavenProjectDocument pomFile : pomDocumentList) {
      Element pomElement = new Element("pom");

      pomListElement.addContent(pomElement);
      JDOMExternalizerUtil.writeField(pomElement, "path", pomFile.getPomFile().getPath());

      Element pluginListElement = new Element("plugin-list");

      pomElement.addContent(pluginListElement);

      List<MavenPluginDocument> pluginDocList = pomFile.getPluginDocumentList();

      for (MavenPluginDocument pluginDoc : pluginDocList) {

        // Store only those plugins, which were manually added by the user
        if (!pluginDoc.isMemberOfPom()) {
          JDOMExternalizerUtil.writeField(pluginListElement, "path", pluginDoc.getPluginPath());
        }
      }
    }
  }

  /**
   * Method description
   *
   * @return Document me!
   */
  @NotNull
  public String getComponentName() {
    return PluginConstants.PROJECT_COMPONENT_NAME;
  }

  /**
   * Method description
   *
   * @return Document me!
   */
  @Nls
  public String getDisplayName() {
    return PluginConstants
        .PLUGIN_PROJECT_DISPLAY_NAME;    // To change body of implemented methods use File | Settings | File Templates.
  }

  /**
   * Method description
   *
   * @return Document me!
   */
  @Nullable
  @NonNls
  public String getHelpTopic() {
    return null;
  }

  /**
   * Method description
   *
   * @return Document me!
   */
  public Icon getIcon() {
    return GuiUtils
        .createImageIcon(PluginConstants
            .ICON_APPLICATION_BIG);    // To change body of implemented methods use File | Settings | File Templates.
  }

  /**
   * Method description
   *
   * @return Document me!
   */
  public MavenBuildApplicationComponent getMavenBuildApplicationComponent() {
    return mavenBuildApplicationComponent;
  }

  /**
   * Method description
   *
   * @return Document me!
   */
  public MavenBuildProjectToolWindowForm getMavenToolWindowForm() {
    return mavenToolWindowForm;
  }

  /**
   * Method description
   *
   * @return Document me!
   */
  public PluginContext getPluginContext() {
    return pluginContext;
  }

  /**
   * Method description
   *
   * @return Document me!
   */
  public Project getPluginProject() {
    return pluginProject;
  }

  /**
   * Method description
   *
   * @return Document me!
   */
  public MavenBuildProjectPluginSettings getPluginSettings() {
    return pluginSettings;
  }

  /**
   * Method description
   *
   * @return Document me!
   */
  public List<MavenProjectDocument> getPomDocumentList() {
    return pomDocumentList;
  }

  private void getPomFiles(VirtualFile virtualFile, Set<MavenProjectDocument> pomFileList) {
    VirtualFile[] children = virtualFile.getChildren();

    if (children == null) {
      return;
    }

    for (VirtualFile child : children) {
      if (child.getName().equals(PluginConstants.POM_FILE_NAME)) {
        if (!isPomInList(pomFileList, child)) {
          pomFileList.add(new MavenProjectDocumentImpl(child));
        }
      }

      getPomFiles(child, pomFileList);
    }
  }

  private Set<MavenProjectDocument> getPomFilesOfProject(ProjectRootManager projectRootManager) {
    VirtualFile[] contentRoots = projectRootManager.getContentRoots();

    for (VirtualFile contentRoot : contentRoots) {
      getPomFiles(contentRoot, mavenPomList);
    }

    return mavenPomList;
  }

  /**
   * Method description
   *
   * @return Document me!
   */
  public PluginConfigDocument.PluginConfig getProjectPluginConfiguration() {
    try {
      XmlOptions xmlOptions = new XmlOptions();
      Map<String, String> xmlOptionsMap = new Hashtable<String, String>();

      xmlOptionsMap.put("", "org/apache/maven/plugin");
      xmlOptions.setLoadSubstituteNamespaces(xmlOptionsMap);
      IdeaMavenPluginDocument ideaMavenPluginDoc = IdeaMavenPluginDocument.Factory.parse(
          this.getClass().getResource(
              PluginConstants.PLUGIN_CONFIG_FILENAME), xmlOptions);

      return ideaMavenPluginDoc.getIdeaMavenPlugin().getPluginConfig();
    } catch (Exception e) {
      ErrorHandler.processAndShowError(pluginContext, e);
    }

    return null;
  }

  /**
   * Method description
   *
   * @return Document me!
   */
  public boolean isModified() {
    return (form != null) && form.isModified(pluginSettings);
  }

  private boolean isPomInList(Set<MavenProjectDocument> pomFileList, VirtualFile child) {
    for (MavenProjectDocument existingEntry : pomFileList) {
      if (existingEntry.getPomFile().getPath().equals(child.getPath())) {
        return true;
      }
    }

    return false;
  }

  /**
   * Method description
   *
   * @param mavenBuildApplicationComponent Document me!
   */
  public void setMavenBuildApplicationComponent(
      MavenBuildApplicationComponent mavenBuildApplicationComponent) {
    this.mavenBuildApplicationComponent = mavenBuildApplicationComponent;
  }

  /**
   * Method description
   *
   * @param mavenToolWindowForm Document me!
   */
  public void setMavenToolWindowForm(MavenBuildProjectToolWindowForm mavenToolWindowForm) {
    this.mavenToolWindowForm = mavenToolWindowForm;
  }

  /**
   * Method description
   *
   * @param pluginContext Document me!
   */
  public void setPluginContext(PluginContext pluginContext) {
    this.pluginContext = pluginContext;
  }

  /**
   * Method description
   *
   * @param pluginProject Document me!
   */
  public void setPluginProject(Project pluginProject) {
    this.pluginProject = pluginProject;
  }

  /**
   * Method description
   *
   * @param pluginSettings Document me!
   */
  public void setPluginSettings(MavenBuildProjectPluginSettings pluginSettings) {
    this.pluginSettings = pluginSettings;
  }

  /**
   * Method description
   *
   * @param pomDocumentList Document me!
   */
  public void setPomDocumentList(List<MavenProjectDocument> pomDocumentList) {
    this.pomDocumentList = pomDocumentList;
  }
}
